/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    
    $(document).ready(function() {
    
        // If any key is pressed
        $(window).keypress(function(e){
            var charTyped = keyCodeToCharFromEvent(e);
            
            // Adjust the key for the character (add bump if F or J)
            adjustKeyForCharacter(charTyped);

            // Set text for key (keyText)
            $("#pressedKey").html(charTyped);
        });
        
        // Check if any special key was pressed
        $(window).keydown(function(e){
            var keyCode = e.keyCode;
            var newClass = "";
            
            switch(keyCode) {
                case 8: // Backspace
                    newClass = "backspace";
                    break;
                case 9: // Tab
                    newClass = "tab";
                    break;
                case 13: // Return key
                    newClass = "return";
                    break;
                case 16: // Shift
                    newClass = "shift";
                    break;
                case 17: // Ctrl
                    newClass = "ctrl";
                    break;
                case 18: // option / alt
                    newClass = "option";
                    break;
                case 20: // Capslock
                    newClass = "capslock";
                    break;
                case 27: // ESC
                    newClass = "esc";
                    break;
                case 32: // Spacebar
                    newClass = "space";
                    break;
                case 33: // Page Up
                    newClass = "pageUp";
                    break;
                case 34: // Page Down
                    newClass = "pageDown";
                    break;
                case 35: // End
                    newClass = "end";
                    break;
                case 36: // Home
                    newClass = "home";
                    break;
                case 37: // Arrow left
                    newClass = "arrowLeft";
                    break;
                case 38: // Arrow up
                    newClass = "arrowUp";
                    break;
                case 39: // Arrow right
                    newClass = "arrowRight";
                    break;
                case 40: // Arrow down
                    newClass = "arrowDown";
                    break;
                case 46: // Delete
                    newClass = "delete";
                    break;
                case 91: // Command (left)
                    newClass = "command";
                    break;
                case 93: // Command (right)
                    newClass = "command";
                    break;
                default:
                    newClass = "";
                    break;
            }
            
            // Update image container with new class
            $("#specialKey").attr("class", newClass);
            
            // Is an image set?
            if(newClass != "") {
                // Remove text from key
                $("#pressedKey").html("");
                // Remove bump from key
                document.getElementById("keyBump").className = "";
            }
            
            // Set keycode
            $("#keyCodeText").html("Keycode " + keyCode);
        });
        // End of keydown event
        
        // Go to website if logo is clicked
        $("#logo").click(function(e){
            e.preventDefault();
            var websiteURL = "http://tobiasahlin.com";	// replace with the website URL to show
            widget.openURL(websiteURL);
        });
        
        // Disable and Enable interface upon blur and focus
        $(window).blur(function(x){
            $("#front").addClass("unactive")
        }).focus(function(x){
            $("#front").removeClass("unactive")
        });

    });
    // End of jQuery ready method
}


// 
// Function: keyCodeCharacterIsBlacklisted(keyCode)
// Returns true if there's an image available for a character
// that should be shown instead of that character
//
function keyCodeCharacterIsBlacklisted(keyCode) {
    var blackListedCharacters = "63232,63233,63234,63235,63272,63273,63275,63276,63277".split(",").map(function(x){return parseInt(x)});
    
    for(var i = 0; i < blackListedCharacters.length; i++) {
        if (blackListedCharacters[i] == keyCode) return true;
    }
    
    return false;
}

function keyCodeToCharFromEvent(e){
    
    e = e || window.event;
    var charCode = e.which || e.keyCode;
    var charTyped = String.fromCharCode(charCode);
    
    if (keyCodeCharacterIsBlacklisted(e.keyCode)) {
        charTyped = "";
    } else if (e.keyCode >= 63236 && e.keyCode <= 63247) { // It's a FX-button!
        charTyped = "F" + (e.keyCode - 63235);
    }
    
    return charTyped;
}

// 
// Function: adjustKeyForCharacter(character)
// If the key is F or J, add the key bump
//
function adjustKeyForCharacter(c) {
    var bumpObject = document.getElementById("keyBump");
    c = c.toUpperCase();
    if (c == "J" || c == "F") {
        bumpObject.className = "visible";        
    } else {
        bumpObject.className = "";
    }
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}
